Collect deleted users

Bug #1870058 reported by Didier Roche on 2020-04-01
8
This bug affects 1 person
Affects Status Importance Assigned to Milestone
shadow (Ubuntu)
Medium
Didier Roche
Focal
Medium
Didier Roche
zsys (Ubuntu)
Medium
Didier Roche
Focal
Medium
Didier Roche

Bug Description

[Impact]
 * Deleting users were preserving corresponding ZFS user datasets, without marking them for cleanup.
 * This is covered by dedicated use cases.

[Test Case]
 1. Ensure you have a foo user:
 2. Run userdel --remove foo
 3. Check that rpool/USERDATA/foo_xxxx has its content removed and is not mounted
 4. zfs get com.ubuntu.zsys:bootfs-dataset rpool/USERDATA/foo_xxxx is not associated with current system dataset
---
Other use case:
 1.Ensure you have a foo user:
 2. Run userdel foo
 3. Check that rpool/USERDATA/foo_xxxx still has its content, but is not mounted.
 4. zfs get com.ubuntu.zsys:bootfs-dataset rpool/USERDATA/foo_xxxx is not associated with current system dataset
---
On a non ZFS installation :
 1. Ensure you have a foo user:
 2. Run userdel --remove foo
 3. The user is deleted, no error occured.
---
On a non ZFS installation with ZSys installed :
 1. Ensure you have a foo user:
 2. Run userdel --remove foo
 3. The user is deleted, no error occured.

[Regression Potential]
 * A new hidden command is added, triggered by userdel.
 * Tests are covering this new command and GRPC request.
 * The methodology is similar to useradd and usermod. The dependency between shadow and zsys is weak on purpose:
 - the ZSys hidden command is available and is a no-op if not called
 - if calling the command failed on userdel, nothing is done on ZSys side, but the code path is similar to ZSys not being installed or running on a non ZFS system.

----

Ideally, we would untag them as part of GC so that we can clean them up later. However, those can be linked to states on other pools with same pool name than targetted one, and it will be hard to match them.

Give a command for users to see them in status and then manually remove suspicious datasets ?

Didier Roche (didrocks) on 2020-04-01
description: updated
Didier Roche (didrocks) on 2020-04-07
description: updated
Changed in zsys (Ubuntu):
status: New → Triaged
importance: Undecided → Medium
Didier Roche (didrocks) on 2020-06-01
summary: - Collect unmatched bootfs-datasets on all userdata
+ Collect deleted users
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package zsys - 0.5.0

---------------
zsys (0.5.0) groovy; urgency=medium

  [ Jean-Baptiste Lallement ]
  [ Didier Roche ]
  * Fix infinite GC loop (LP: #1870461)
  * Enhance timeout handling to avoid error rpc error: code = DeadlineExceeded
    desc = context deadline exceeded while the daemon is doing work
    (LP: #1875564)
  * Stop taking automated or manual snapshot when there is less than 20% of
    free disk space (LP: #1876334)
  * Enable trim support for upgrading users (LP: #1881540)
  * Only clean up previously linked user datasets when unlinked under USERDATA
    (LP: #1881538)
  * Strategy for deleted user datasets via a new hidden command called by
    userdel (LP: #1870058)
  * Get better auto snapshots message when integrated to apt (LP: #1875420)
  * Update LastUsed on shutdown via a new hidden command service call
    (LP: #1881536)
  * Prevent segfault immediately after install when zfs kernel module isn't
    loaded (LP: #1881541)
  * Don’t try to autosave gdm user (and in general non system user), even if
    systemd --user is started for them. (LP: #1881539)
  * Prevent apt printing errors when zsys is removed without purge
    (LP: #1881535)
  * Some tests enhancements:
    - new tests for all the above
    - allow setting a different local socket for debugging/tests purposes only
    - ascii order datasets in golden files
  * Typos and messages fixes. Direct prints are not prefixed with INFO
    anymore.
  * Refreshed po and readme with the above.

 -- Didier Roche <email address hidden> Mon, 01 Jun 2020 09:26:52 +0200

Changed in zsys (Ubuntu):
status: Triaged → Fix Released
Didier Roche (didrocks) on 2020-06-09
Changed in shadow (Ubuntu):
importance: Undecided → Medium
assignee: nobody → Didier Roche (didrocks)
Changed in zsys (Ubuntu):
assignee: nobody → Didier Roche (didrocks)
Changed in shadow (Ubuntu Focal):
assignee: nobody → Didier Roche (didrocks)
importance: Undecided → Medium
Changed in zsys (Ubuntu Focal):
assignee: nobody → Didier Roche (didrocks)
importance: Undecided → Medium
Changed in shadow (Ubuntu):
status: New → Fix Released
Didier Roche (didrocks) on 2020-06-09
description: updated

On Tue, Jun 09, 2020 at 09:04:00AM -0000, Didier Roche wrote:
> + Other use case:
> + On a non ZFS installation :
> + On a non ZFS installation with ZSys installed :

Can I suggest a ZFS installation that doesn't have zsys installed, as
well? There's at least a dozen of us that used the guide from the ZFS On
Linux wiki on running Ubuntu on ZFS on LUKS, and may not have zsys
installed (I'm a bit afraid of trying it myself, perhaps assumptions it
makes aren't assumptions I made.)

Thanks

Didier Roche (didrocks) wrote :

ZFS installation without ZSys installed is equivalent to non ZFS installation without ZSys. userdel calls ZSys which does the cleanup. If you don’t have it, nothing will change from today’s behavior.

Seth Arnold (seth-arnold) wrote :

Thanks Didier, that's perfect. :)

Hello Didier, or anyone else affected,

Accepted zsys into focal-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/zsys/0.4.6 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, what testing has been performed on the package and change the tag from verification-needed-focal to verification-done-focal. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-focal. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance for helping!

N.B. The updated package will be released to -updates after the bug(s) fixed by this package have been verified and the package has been in -proposed for a minimum of 7 days.

Changed in zsys (Ubuntu Focal):
status: New → Fix Committed
tags: added: verification-needed verification-needed-focal
Brian Murray (brian-murray) wrote :

Hello Didier, or anyone else affected,

Accepted shadow into focal-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/shadow/1:4.8.1-1ubuntu5.20.04 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, what testing has been performed on the package and change the tag from verification-needed-focal to verification-done-focal. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-focal. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance for helping!

N.B. The updated package will be released to -updates after the bug(s) fixed by this package have been verified and the package has been in -proposed for a minimum of 7 days.

Changed in shadow (Ubuntu Focal):
status: New → Fix Committed
Jean-Baptiste Lallement (jibel) wrote :

SRU verification for Focal:
I have reproduced the problem in focal and have verified that the version of zsys 0.4.6 and shadow 1:4.8.1-1ubuntu5.20.04 in -proposed fixes the issue.

Marking as verification-done

tags: added: verification-done verification-done-focal
removed: verification-needed verification-needed-focal
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package shadow - 1:4.8.1-1ubuntu5.20.04

---------------
shadow (1:4.8.1-1ubuntu5.20.04) focal; urgency=medium

  * debian/patches/1015_add_zsys_support.patch:
    - Add support for ZSys user deletion (LP: #1870058)
    - Fix a build warning

 -- Didier Roche <email address hidden> Thu, 28 May 2020 08:37:47 +0200

Changed in shadow (Ubuntu Focal):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package zsys - 0.4.6

---------------
zsys (0.4.6) focal; urgency=medium

  [ Jean-Baptiste Lallement ]
  [ Didier Roche ]
  * Fix infinite GC loop (LP: #1870461)
  * Enhance timeout handling to avoid error rpc error: code = DeadlineExceeded
    desc = context deadline exceeded while the daemon is doing work
    (LP: #1875564)
  * Stop taking automated or manual snapshot when there is less than 20% of
    free disk space (LP: #1876334)
  * Enable trim support for upgrading users (LP: #1881540)
  * Only clean up previously linked user datasets when unlinked under USERDATA
    (LP: #1881538)
  * Strategy for deleted user datasets via a new hidden command called by
    userdel (LP: #1870058)
  * Get better auto snapshots message when integrated to apt (LP: #1875420)
  * Update LastUsed on shutdown via a new hidden command service call
    (LP: #1881536)
  * Prevent segfault immediately after install when zfs kernel module isn't
    loaded (LP: #1881541)
  * Don’t try to autosave gdm user (and in general non system user), even if
    systemd --user is started for them. (LP: #1881539)
  * Prevent apt printing errors when zsys is removed without purge
    (LP: #1881535)
  * Some tests enhancements:
    - new tests for all the above
    - allow setting a different local socket for debugging/tests purposes only
    - ascii order datasets in golden files
  * Typos and messages fixes. Direct prints are not prefixed with INFO
    anymore.
  * Refreshed po and readme with the above.

 -- Didier Roche <email address hidden> Mon, 01 Jun 2020 09:26:52 +0200

Changed in zsys (Ubuntu Focal):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for shadow has completed successfully and the package is now being released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers